// VirtualBankDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VirtualBank.h"
#include "VirtualBankDlg.h"
#include "socket.h"
#include <list>
using namespace std;


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

    #define WM_LOG_INSERTSTRING                     (WM_USER + 100)
    #define WM_LOG_CLEAR                            (WM_USER + 101)
    #define WM_PIN_UPDATE                           (WM_USER + 102)
    
    #define LOG_STRING_MAX_SIZE                     1000
#define     SCSAT_SOCKET_TIMEOUT            5
#define PROXY_PORT      4001



#define LOG_INSERTSTRING(message)                   { char* log = new char[LOG_STRING_MAX_SIZE]; strncpy_s(log, LOG_STRING_MAX_SIZE, (LPCTSTR) message, LOG_STRING_MAX_SIZE); pBank->PostMessage(WM_LOG_INSERTSTRING, (WPARAM) log, TRUE); }
#define PIN_UPDATE(message)                   { char* log = new char[LOG_STRING_MAX_SIZE]; strncpy_s(log, LOG_STRING_MAX_SIZE, (LPCTSTR) message, LOG_STRING_MAX_SIZE); pBank->PostMessage(WM_PIN_UPDATE, (WPARAM) log, TRUE); }
#define LOG_CLEAR                                   { pBank->PostMessage(WM_LOG_CLEAR, NULL, FALSE); }


CVirtualBankDlg*    pBank;
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVirtualBankDlg dialog


LRESULT CVirtualBankDlg::OnLogInsertString(WPARAM wParam, LPARAM lParam) {    
    // INSERT INTO LOG
    Log_InsertString((LPCTSTR) ((char*) wParam), (BOOL) lParam);  
    
    // CLEAR LOG STRING    
    delete[] (char*) wParam;

    return 0;
}

LRESULT CVirtualBankDlg::OnUpdatePIN(WPARAM wParam, LPARAM lParam) {    
            
    UpdateData(TRUE);
    m_PIN = (char*) wParam;
    m_PIN.Trim();
    UpdateData(FALSE);
    
    
    // CLEAR LOG STRING    
    delete[] (char*) wParam;

    return 0;
}


LRESULT CVirtualBankDlg::OnLogClear(WPARAM wParam, LPARAM lParam) {    
    // INSERT INTO LOG
    Log_Clear();  
    
    return 0;
}


CVirtualBankDlg::CVirtualBankDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVirtualBankDlg::IDD, pParent)
    , m_logs(_T(""))
    , m_PIN(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	pBank = this;
	m_customer = 0;
	m_runAsProxy = FALSE;
	
	m_pSocketServer = NULL;
	m_pProxyThread = NULL; 
    CString tempCmdLine;
    tempCmdLine = GetCommandLine();
    tempCmdLine += " ";
    int pos = 0;
    if ((pos = tempCmdLine.Find("ProxyIP:")) != -1) {
        int pos2 = tempCmdLine.Find(" ", pos);
        pos += (int)strlen("ProxyIP:");
        m_proxyIP = tempCmdLine.Mid(pos, pos2 - pos);
    }
    if ((pos = tempCmdLine.Find("RunAsProxy")) != -1) {
        m_runAsProxy = TRUE;
    }


}

void CVirtualBankDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_LOG, m_logs);
    DDX_Text(pDX, IDC_PIN, m_PIN);
}

BEGIN_MESSAGE_MAP(CVirtualBankDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(IDOK, &CVirtualBankDlg::OnBnClickedOk)
    ON_MESSAGE(WM_LOG_INSERTSTRING, &OnLogInsertString)
    ON_MESSAGE(WM_PIN_UPDATE, &OnUpdatePIN)
    
    ON_MESSAGE(WM_LOG_CLEAR, &OnLogClear)
    ON_EN_CHANGE(IDC_PIN, &CVirtualBankDlg::OnEnChangePin)
END_MESSAGE_MAP()


// CVirtualBankDlg message handlers

UINT MonitorReaders(LPVOID pParam) {
   int status = 0;
   CPCSCMngr pcscMngr;
   
   CString readerName;
   CString  ATR;
   CString  message;
   

    char*   reader;
    int     pos;
    char    readers[10000];   
    DWORD   readersLen = 10000; 
    list<CString>   readersList;
    list<CString>::iterator  iter;
    
/*
    SocketClient*    m_pCardSocket;

        std::string sIP("localhost");
        m_pCardSocket = new SocketClient(sIP, 4001);
        string l = m_pCardSocket->ReceiveLine(SCSAT_SOCKET_TIMEOUT);
        message.Format("> SACSAT connect ... %s", l.c_str());
        LOG_INSERTSTRING(message);
/**/
    while (true) {

        readersLen = 10000; 
        if ((status = pcscMngr.GetAvailableReaders(readers, &readersLen)) == STAT_OK) {
            // PARSE NULL SEPARATED ARRAY
            pos = 0;
            while ((DWORD) pos < readersLen) {
                reader = &(readers[pos]);
                if (strlen(reader) == 0) {
                    pos++;
                }
                else {
                    readersList.push_back(reader);

                    pos = pos + (DWORD) strlen(reader) + 1;
                }
            }
        }


        pBank->m_customer = 0;
        for (iter = readersList.begin(); iter != readersList.end(); iter++) {

            

            message.Format("Reader %s ", *iter);
            LOG_INSERTSTRING(message);


            //m_pCardSocket->SendLine("getFlashKey#6c 73 54 cf 45 6d 2e 4c b7 a2 9d cc ae ce 32 79#01 02 03 04 05 06 07 08 a1 a2 a3 a4 a5 a6 a7 a8#");

            // INIT SCSAT CONNECTION
//            m_pCardSocket->SendLine((LPCTSTR) message);


            if ((status = pcscMngr.OpenSession(*iter)) == STAT_OK) {	
                pBank->m_customer = 100;
                //pcscMngr.ResetCard();

                if ((status = pcscMngr.GetATR(&ATR)) == STAT_OK) {
                    if (ATR.CompareNoCase("3B 7D 94 00 00 80 31 80 65 B0 83 11 C0 A9 83 00 90 00") == 0) {
                        pBank->m_customer = 1;
                    }
                }
                
                if ((status = pcscMngr.GetATR(&ATR)) == STAT_OK) {
                    if (ATR.CompareNoCase("3B 7E 94 00 00 80 25 A0 00 00 00 28 56 80 10 21 00 01 08") == 0) {
                        pBank->m_customer = 2;
                    }
                }
                if ((status = pcscMngr.GetATR(&ATR)) == STAT_OK) {
                    if (ATR.CompareNoCase("3B 7A 94 00 00 80 65 A2 01 01 01 3D 72 D6 43") == 0) {
                        pBank->m_customer = 3;
                    }
                }
                if ((status = pcscMngr.GetATR(&ATR)) == STAT_OK) {
                    if (ATR.CompareNoCase("3B 68 00 00 80 66 A2 06 01 01 7F 0E") == 0) {
                        pBank->m_customer = 4;
                    }
                }

                
            }
                pcscMngr.CloseSession();
        }

        pBank->PostMessage(WM_PAINT);
        readersList.clear();
        Sleep(1000);
        LOG_CLEAR;
        
    }
    return status;
}


UINT Answer(void* a) {
    Socket* pSocket = (Socket*) a;
    int         status = STAT_OK;
    CString     value;
    CString     command;
    CString     response;
    CString     message;
    int         pos = 0;
    int         pos2 = 0;

    while (1) {
        Sleep(100);

        if (pSocket != NULL) {
       
            // TERMINATE IF REQUIRED
            if (pBank->m_bStopThread) return 0; 
        
            std::string r = pSocket->ReceiveLine();
            value = r.c_str();
            
            if (value != "") { 
                PIN_UPDATE(value);        
            }
            
        }
    }
     // Delete served socket 
    delete pSocket;

    return 0;
}


UINT StartProxy(void* a) {
    SocketServer* pSocketServer = (SocketServer*) a; 

    LOG_INSERTSTRING("Proxy started");        

    while (1) {
        try {
            Socket* s=pSocketServer->Accept();

            //LOG_INSERTSTRING("\nNew connection detected and waiting for service");        

            // TERMINATE IF REQUIRED
            if (pBank->m_bStopThread) break;

            pBank->m_pProxyThread = AfxBeginThread(Answer, (void*) s, THREAD_PRIORITY_NORMAL); 

        }
        catch(...) {
            // TERMINATE IF REQUIRED (POSSIBLE REASON FOR EXCEPTION)
            if (pBank->m_bStopThread) break;
            else LOG_INSERTSTRING("Exception in pSocketServer->Accept");        
        }
    }

    return 0; 
}

BOOL CVirtualBankDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


        AfxBeginThread(MonitorReaders, NULL, THREAD_PRIORITY_LOWEST); 


    if (m_runAsProxy) {
        // TERMINATE PREVIOUS THREAD
        if (m_pProxyThread != NULL) {
            m_bStopThread = TRUE;
            if (m_pSocketServer) m_pSocketServer->Close();
            Sleep(1000);
            if (m_pSocketServer != NULL) delete m_pSocketServer;
        }
        
        m_pSocketServer = new SocketServer(PROXY_PORT, 1);   

        CString message;
        message.Format("Starting proxy on port %d", PROXY_PORT);
        LOG_INSERTSTRING(message);        

        m_bStopThread = FALSE;
        m_pProxyThread = AfxBeginThread(StartProxy, (void*) m_pSocketServer, THREAD_PRIORITY_NORMAL); 
    }

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVirtualBankDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVirtualBankDlg::Log_InsertString(CString message, BOOL bShowTime) {
    int             status = STAT_OK;
    char            timeStr[MAX_PATH];

    UpdateData(TRUE);

    message.Replace("\n", "\r\n");

    // TIME STAMP
    if (bShowTime) {
        message.Insert(0, "  ");
        _strtime_s(timeStr, MAX_PATH);
        message.Insert(0, timeStr); 
    }
    
    // ADD ENDING "\r\n" IF NOT ALREADY PRESENT
    if (message.Right(2) != "\r\n") message += "\r\n";

    // ADD ENDING "\r\n" TO EXISTING LOG MESSAGE IF NOT ALREADY PRESENT
    if (m_logs.Right(2) != "\r\n") m_logs += "\r\n";
    m_logs += message;

    UpdateData(FALSE);

    Log_EnsureVisibleLastLine();
}

void CVirtualBankDlg::Log_Clear() {
    int             status = STAT_OK;

    UpdateData(TRUE);

    m_logs = "";

    UpdateData(FALSE);

}

void CVirtualBankDlg::Log_EnsureVisibleLastLine() {
    int     status = STAT_OK;
    
    CEdit* pEdit;
    if ((pEdit = (CEdit*) GetDlgItem(IDC_LOG)) != NULL) {
        pEdit->LineScroll(pEdit->GetLineCount());
    }
}



void CVirtualBankDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	
	// TODO: Add extra initialization here
    CString szFilename;
    
    switch (m_customer) {
        case 1: szFilename = "cust1.bmp"; break;
        case 2: szFilename = "cust2.bmp"; break;
        case 3: szFilename = "cust3.bmp"; break;
        case 4: szFilename = "cust4.bmp"; break;
        case 100: szFilename = "custUnknown.bmp"; break;
        default: {
            if (m_proxyIP == "") szFilename = "noCust.bmp"; 
            else szFilename = "fakeBank.bmp"; 
            break;
        }
    }


    HBITMAP hBmp = (HBITMAP)::LoadImage(NULL,szFilename,
                                     IMAGE_BITMAP,0,0,
                                     LR_LOADFROMFILE|LR_CREATEDIBSECTION);

   CBitmap bmp;
   bmp.Attach(hBmp);

    
   CClientDC dc(this);
   CDC bmDC;
   bmDC.CreateCompatibleDC(&dc);
   CBitmap *pOldbmp = bmDC.SelectObject(&bmp);

   BITMAP  bi;
   bmp.GetBitmap(&bi);

   dc.BitBlt(0,0,bi.bmWidth,bi.bmHeight,&bmDC,0,0,SRCCOPY);

   bmDC.SelectObject(pOldbmp);
   
 /**/  
   
 		
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVirtualBankDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CVirtualBankDlg::OnBnClickedOk()
{
    // TODO: Add your control notification handler code here
    //OnOK();
}

void CVirtualBankDlg::OnBnClickedButton1()
{

    CString szFilename ("C:\\test.bmp");
   HBITMAP hBmp = (HBITMAP)::LoadImage(NULL,szFilename,
                             IMAGE_BITMAP,0,0,
                             LR_LOADFROMFILE|LR_CREATEDIBSECTION);

   CBitmap bmp;
   bmp.Attach(hBmp);

    
   CClientDC dc(this);
   CDC bmDC;
   bmDC.CreateCompatibleDC(&dc);
   CBitmap *pOldbmp = bmDC.SelectObject(&bmp);
   
   delete pOldbmp;

   BITMAP  bi;
   bmp.GetBitmap(&bi);

   dc.BitBlt(0,0,bi.bmWidth,bi.bmHeight,&bmDC,0,0,SRCCOPY);

   bmDC.SelectObject(pOldbmp);
/*
HBITMAP hbLogo = (HBITMAP)LoadImage(AfxGetInstanceHandle(), "c:\\test.bmp", IMAGE_BITMAP, 200, 100, LR_LOADFROMFILE);
if(hbLogo)
{
m_BankPicture.SetBitmap(hbLogo);
}
/**/   

}

void CVirtualBankDlg::OnEnChangePin()
{
    UpdateData(TRUE);

    if (m_proxyIP != "") {    
        SocketClient*    m_pCardSocket;

        //std::string sIP("localhost");
        std::string sIP((LPCTSTR) m_proxyIP);
        m_pCardSocket = new SocketClient(sIP, 4001);
        CString message;
        //message.Format("Typed PIN: %s", m_PIN);
        message.Format("%s", m_PIN);
        m_pCardSocket->SendLine((LPCTSTR) message);
        
        delete m_pCardSocket;
    }
        
    UpdateData(FALSE);
}

